// 	WOSA/XRT Excel 5.0 AddIn Version 1.00
//
//	COPYRIGHT:
//
//  	(C) Copyright Microsoft Corp. 1994.  All rights reserved.
//
//   	You have a royalty-free right to use, modify, reproduce and
//   	distribute the Sample Files (and/or any modified version) in
//   	any way you find useful, provided that you agree that
//   	Microsoft has no warranty obligations or liability for any
//   	Sample Application Files which are modified.
//
//
// 	Revision History
//    	October 15, 1994   rc    Version 1.00 Release

class CRequests;
class CImpIAdviseSink;

class FAR CDataObject : public _IMyDataObject
{

friend	class CCache;
friend	class CDataObjects;
friend 	class CImpIAdviseSink;
friend 	class CProperties;
friend 	class CRequest;

public:		
	STDMETHOD(QueryInterface)(REFIID riid, LPVOID FAR* ppvObj);
	STDMETHOD_(ULONG, AddRef)();
	STDMETHOD_(ULONG, Release)();
	
    // IDispatch methods 
    STDMETHOD(GetTypeInfoCount)(UINT FAR* pctinfo);
    STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo FAR* FAR* pptinfo);
    STDMETHOD(GetIDsOfNames)(REFIID riid, OLECHAR FAR* FAR* rgszNames,
    	UINT cNames, LCID lcid, DISPID FAR* rgdispid);
    STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid, LCID lcid,
      	WORD wFlags,DISPPARAMS FAR* pdispparams, VARIANT FAR* pvarResult,
      	EXCEPINFO FAR* pexcepinfo, UINT FAR* puArgErr);

	//Exported methods    
    STDMETHOD_(void, put_IncludeRequestNames)(short Value);
    STDMETHOD_(short, get_IncludeRequestNames)();
    STDMETHOD_(void, put_MaxRequests)(long Count);
    STDMETHOD_(long, get_MaxRequests)();
    STDMETHOD_(void, put_MaxProperties)(long Count);
    STDMETHOD_(long, get_MaxProperties)();
    STDMETHOD_(BSTR, get_OnDataChange)(void);
    STDMETHOD_(void, put_OnDataChange)(BSTR newvalue);
    STDMETHOD_(IDispatch *, get_Requests)(void);
    STDMETHOD_(IDispatch *, get_DataItems)(void);
    STDMETHOD_(void, put_UpdateRange)(IDispatch * newvalue);
    STDMETHOD_(IDispatch *, get_UpdateRange)(void);
    STDMETHOD_(BSTR, get_Name)(void);
    STDMETHOD_(long, get_Status)(void);
    STDMETHOD_(long, get_UpdateFrequency)(void);
    STDMETHOD_(void, put_UpdateFrequency)(long newval);
    STDMETHOD_(short, get_MostRecentOnly)(void);
    STDMETHOD_(void, put_MostRecentOnly)(short newval);
	STDMETHOD_(short, get_Active)(void);
    STDMETHOD_(void, put_Active)(short newval);
    STDMETHOD_(BSTR, get_ColumnDelimiter)(void);
    STDMETHOD_(void, put_ColumnDelimiter)(BSTR newval);
    STDMETHOD_(BSTR, get_Username)(void);
    STDMETHOD_(void, put_Username)(BSTR newval);
    STDMETHOD_(BSTR, get_Password)(void);
    STDMETHOD_(void, put_Password)(BSTR newval);
    STDMETHOD_(VARIANT, get_WorkstationID)(void);
    STDMETHOD_(void, put_WorkstationID)(VARIANT newval);
    STDMETHOD_(VARIANT, get_DataUserID)(void);
    STDMETHOD_(void, put_DataUserID)(VARIANT newval);

    STDMETHOD_(void, Activate)();
    STDMETHOD_(void, Copy)();
    STDMETHOD_(VARIANT, Close)(VARIANT SaveChanges, VARIANT FileName);
    STDMETHOD_(VARIANT, Save)();
    STDMETHOD_(VARIANT, SaveAs)(VARIANT FileName);
    STDMETHOD_(IDispatch *, get_Object)();
    STDMETHOD_(VARIANT, get_Application)();
    STDMETHOD_(void, put_Visible)(short newvalue);
    STDMETHOD_(short, get_Visible)();
    STDMETHOD_(short, get_Saved)();
    STDMETHOD_(BSTR, get_Path)();
    STDMETHOD_(BSTR, get_FullName)();
    STDMETHOD_(BSTR, get_Title)();
    STDMETHOD_(void, put_Title)(BSTR newval);
    STDMETHOD_(short, GetData)(BSTR WorkbookName, BSTR WorksheetName, BSTR Range);
	STDMETHOD_(short, get_UpdateMaxRange)();
	STDMETHOD_(void, put_UpdateMaxRange)(short Value);
	STDMETHOD_(short, get_UpdatePerCellCount)();
	STDMETHOD_(void, put_UpdatePerCellCount)(short Value);
                                                           
	static HRESULT RetrieveDataObjectName(LPDISPATCH pDispatch
			, BSTR FAR *pbstrName);
	
	HRESULT CDataObject::SetDataObjectName(BSTR bstrName);         

	static HRESULT Create(class CDataObject FAR* FAR* ppDataObject
			, LPDISPATCH pXRTDispatch, BSTR bstrName
			, VARIANT vRange) ;

    CDataObject();
    ~CDataObject();

private:
//Helper methods                    
	HRESULT XRTDataItems(LPDISPATCH FAR * ppDispatch);
	HRESULT XRTRequests(LPDISPATCH FAR * ppDispatch);

private:
	BSTR					m_bstrPassThroughFunc;
	LPDISPATCH				m_pDataItemsXRTDispatch;
	LPDISPATCH 				m_pXRTDispatch;			// XRT objects' LPDISPATCH
	LPDATAOBJECT			m_pXRTDataObject;			// XRT object's LPDATAOBJECT
	HWND 					m_hWnd;						// Handle to invisble Window
	DWORD 					m_dwStatus;
	DWORD					m_dwSubStatus;
	DWORD					m_dwVendorData1;
	DWORD					m_dwVendorData2;
	BSTR					m_bstrName;
	LPTYPEINFO				m_ptinfo;
	ULONG					m_cRef;
   	EXCEPINFO 				m_excepinfo;      	// Information to raise an exception on error.
   	BOOL 					m_bRaiseException;	// Properties and methods use this to signal an exception to be raised.
   	BOOL					m_bDontIncludeNames;
    BOOL					m_bUpdateMaxRange;
	class CDirtyCells FAR *	m_pDirtyCells;
	int						m_nUpdatePerCellPercentage;
	CRequests FAR *			m_pRequests;				// DataObject's Requests
	DWORD					m_dwAdviseConnection;	
	CImpIAdviseSink	FAR *	m_pAdviseSink;
	FORMATETC				m_fte;
	HINSTANCE				m_hInstance;                             
	class CRealTimeExt FAR *m_pRealTimeExt; 

public:
	class CCache FAR *		m_pCache;			 
	LPDISPATCH 				m_pUpdateRangeDispatch;	// pDispatch to range on spreadsheet
	BSTR					m_bstrXLCallBackFunc;
	DWORD  					m_dwMaxProperties;
	DWORD   				m_dwMaxRequests;
};

