// 	WOSA/XRT Excel 5.0 AddIn Version 1.00
//
//	COPYRIGHT:
//
//  	(C) Copyright Microsoft Corp. 1994.  All rights reserved.
//
//   	You have a royalty-free right to use, modify, reproduce and
//   	distribute the Sample Files (and/or any modified version) in
//   	any way you find useful, provided that you agree that
//   	Microsoft has no warranty obligations or liability for any
//   	Sample Application Files which are modified.
//
//
// 	Revision History
//    	October 15, 1994   rc    Version 1.00 Release
        
class FAR CDataObjects : public _IDataObjects
{

friend CRealTimeExt;

public:
	HRESULT DisplayStatusWindow(BSTR bstrMsg, float fComplete, BOOL bInvalidate);
	HRESULT HideStatusWindow();

public:
    // IUnknown methods 
   	STDMETHOD(QueryInterface)(REFIID riid, LPVOID FAR* ppvObj);
   	STDMETHOD_(ULONG, AddRef)();
   	STDMETHOD_(ULONG, Release)();

    // IDispatch methods 
    STDMETHOD(GetTypeInfoCount)(UINT FAR* pctinfo);
    STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo FAR* FAR* pptinfo);
    STDMETHOD(GetIDsOfNames)(REFIID riid, OLECHAR FAR* FAR* rgszNames,
    	UINT cNames, LCID lcid, DISPID FAR* rgdispid);
    STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid, LCID lcid,
      	WORD wFlags,DISPPARAMS FAR* pdispparams, VARIANT FAR* pvarResult,
      	EXCEPINFO FAR* pexcepinfo, UINT FAR* puArgErr);
      		
public:
    /* _IDataObjects methods */
	STDMETHOD_(IDispatch*, Add)(LPDISPATCH XRTObject, VARIANT Name, VARIANT Range);
    STDMETHOD_(IDispatch *, CreateObject)(BSTR ProgID, VARIANT vName, VARIANT Range);
    STDMETHOD_(IDispatch *, GetObject)(BSTR FileName, VARIANT Moniker, VARIANT Range);
    STDMETHOD_(IDispatch *, get_Item)(VARIANT Index);		
    STDMETHOD_(void, Remove)(VARIANT Index);
	STDMETHOD_(long, get_Count)(void);
	STDMETHOD_(LPUNKNOWN, get__NewEnum)(void);

    static HRESULT Create(CDataObjects FAR* FAR*);
    CDataObjects();
    ~CDataObjects();

public:
	CCollection					m_col;
	BSTR						m_bstrStatusWndMsg;
	float						m_fComplete;

private:
	LPTYPEINFO					m_ptinfo;
	ULONG						m_cRef;
   	EXCEPINFO 					m_excepinfo;      	// Information to raise an exception on error.
   	BOOL 						m_bRaiseException;	// Properties and methods use this to signal an exception to be raised.
	HWND						m_hWnd;
	class CRealTimeExt 		*	m_pRealTimeExt;                               
};                                    
