// 	WOSA/XRT Excel 5.0 AddIn Version 1.00
//
//	COPYRIGHT:
//
//  	(C) Copyright Microsoft Corp. 1994.  All rights reserved.
//
//   	You have a royalty-free right to use, modify, reproduce and
//   	distribute the Sample Files (and/or any modified version) in
//   	any way you find useful, provided that you agree that
//   	Microsoft has no warranty obligations or liability for any
//   	Sample Application Files which are modified.
//
//
// 	Revision History
//    	October 15, 1994   rc    Version 1.00 Release

class CProperties;                                                            
class CRequest;
class CRequests;
class CCache;

class FAR CProperty : public _IProperty
{

friend CProperties;
friend CRequests;
friend CCache;

public:		
   	STDMETHOD(QueryInterface)(REFIID riid, LPVOID FAR* ppvObj);
   	STDMETHOD_(ULONG, AddRef)();
   	STDMETHOD_(ULONG, Release)();

    // IDispatch methods 
    STDMETHOD(GetTypeInfoCount)(UINT FAR* pctinfo);
    STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo FAR* FAR* pptinfo);
    STDMETHOD(GetIDsOfNames)(REFIID riid, OLECHAR FAR* FAR* rgszNames,
    	UINT cNames, LCID lcid, DISPID FAR* rgdispid);
    STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid, LCID lcid,
      	WORD wFlags,DISPPARAMS FAR* pdispparams, VARIANT FAR* pvarResult,
      	EXCEPINFO FAR* pexcepinfo, UINT FAR* puArgErr);

    // _IProperty methods 
    STDMETHOD_(BSTR, get_Name)(void);
    STDMETHOD_(VARIANT, get_Value)(void);
    STDMETHOD_(IDispatch *, get_Object)();
      
    static HRESULT Create(BSTR bstrName, LPDISPATCH pXRTDispatch, CProperty FAR* FAR* ppProperty); 

    CProperty();
    ~CProperty();

private:
	LPDISPATCH 					m_pXRTDispatch;
	CProperties FAR* 			m_pProperties;
	CRequest FAR *				m_pRequest;
	BOOL						m_bDirectUpdates;
	DWORD 						m_dwIndex;
	DWORD						m_dwPropertyID;
	LPXLOPER					m_pxlProperty;
	BSTR						m_bstrName;
	LPTYPEINFO					m_ptinfo;
	ULONG						m_cRef;
   	EXCEPINFO 					m_excepinfo;      	// Information to raise an exception on error.
   	BOOL 						m_bRaiseException;	// Properties and methods use this to signal an exception to be raised.
};
