// 	WOSA/XRT Excel 5.0 AddIn Version 1.00
//
//	COPYRIGHT:
//
//  	(C) Copyright Microsoft Corp. 1994.  All rights reserved.
//
//   	You have a royalty-free right to use, modify, reproduce and
//   	distribute the Sample Files (and/or any modified version) in
//   	any way you find useful, provided that you agree that
//   	Microsoft has no warranty obligations or liability for any
//   	Sample Application Files which are modified.
//
//
// 	Revision History
//    	October 15, 1994   rc    Version 1.00 Release

class CRequest;

class FAR CRequests : public _IRequests
{

friend CDataObject;
friend CCache;

public:		
   	STDMETHOD(QueryInterface)(REFIID riid, LPVOID FAR* ppvObj);
   	STDMETHOD_(ULONG, AddRef)();
   	STDMETHOD_(ULONG, Release)();

    // IDispatch methods 
    STDMETHOD(GetTypeInfoCount)(UINT FAR* pctinfo);
    STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo FAR* FAR* pptinfo);
    STDMETHOD(GetIDsOfNames)(REFIID riid, OLECHAR FAR* FAR* rgszNames,
    	UINT cNames, LCID lcid, DISPID FAR* rgdispid);
    STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid, LCID lcid,
      	WORD wFlags,DISPPARAMS FAR* pdispparams, VARIANT FAR* pvarResult,
      	EXCEPINFO FAR* pexcepinfo, UINT FAR* puArgErr);
public:
    /* _IDataObjects methods */
    STDMETHOD_(IDispatch *, Add)(VARIANT Name, VARIANT vdispProps);
    STDMETHOD_(IDispatch *, get_Item)(VARIANT Index);		
    STDMETHOD_(void, Remove)(VARIANT Index);
    STDMETHOD_(void, Reset)(void);
    STDMETHOD_(long, get_Count)(void);
    STDMETHOD_(LPUNKNOWN, get__NewEnum)(void);
    STDMETHOD_(IDispatch *, get_DataObject)(void);
    STDMETHOD_(IDispatch *, CreateProperties)(VARIANT property1, VARIANT property2, VARIANT property3, VARIANT property4, VARIANT property5, VARIANT property6, VARIANT property7, VARIANT property8);
    STDMETHOD_(IDispatch *, get_Object)(void);

	HRESULT Add(LPXLOPER pRow, BSTR bstrRequestName, DWORD dwID
		, CRequest FAR * FAR *ppRequest, CNode FAR* FAR* ppNode);

    static HRESULT Create(LPDISPATCH pXRTDispatch, CRequests FAR* FAR* ppRequests) ;

    CRequests();
    ~CRequests();

private:	
	HRESULT XRTItem(VARIANT FAR *pvIndex, LPDISPATCH FAR *ppDispatch);
	HRESULT XRTRemove(VARIANT FAR *pvIndex);
	HRESULT XRTAdd(VARIANT FAR *pvName, VARIANT FAR *pvProperties, LPDISPATCH FAR *ppDispatch);
	HRESULT XRTDataObject(LPDISPATCH FAR *ppDispatch);

public:
	DWORD 						m_dwMaxColCount;

private:
	LPDISPATCH 					m_pXRTDispatch;						 
	CDataObject	FAR *			m_pDataObject;
// TODO: Remove 
//	CRequest FAR *				m_pRequest;
	CCollection					m_col;
	BSTR						m_bstrName;
	LPTYPEINFO					m_ptinfo;
	ULONG						m_cRef;
   	EXCEPINFO 					m_excepinfo;      	// Information to raise an exception on error.
   	BOOL 						m_bRaiseException;	// Properties and methods use this to signal an exception to be raised.
};

