// WOSA/XRT XRTTick Sample OLE Control Version 1.00.001
//
// Copyright (c) 1993-94 Microsoft Corporation, All Rights Reserved.
//
//      This is a part of the Microsoft Source Code Samples. 
//      This source code is only intended as a supplement to 
//      Microsoft Development Tools and/or WinHelp documentation.
//      See these sources for detailed information regarding the 
//      Microsoft samples programs.
//
// xrttippg.cpp : Implementation of the CTickPropPage property page class.

#include "stdafx.h"
#include "xrttick.h"
#include "xrttippg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CTickPropPage, COlePropertyPage)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CTickPropPage, COlePropertyPage)
    //{{AFX_MSG_MAP(CTickPropPage)
    ON_BN_CLICKED(IDC_ABOUT, OnAbout)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CTickPropPage, "XRTTick.TickerPropPage.1",
    0x5aabe534, 0xdaf0, 0x11cd, 0x84, 0x45, 0x0, 0xaa, 0x0, 0x33, 0x97, 0x10)


/////////////////////////////////////////////////////////////////////////////
// CTickPropPage::CTickPropPageFactory::UpdateRegistry -
// Adds or removes system registry entries for CTickPropPage

BOOL CTickPropPage::CTickPropPageFactory::UpdateRegistry(BOOL bRegister)
{
    if (bRegister)
        return AfxOleRegisterPropertyPageClass(AfxGetInstanceHandle(),
            m_clsid, IDS_XRTTICKER_PPG);
    else
        return AfxOleUnregisterClass(m_clsid, NULL);
}


/////////////////////////////////////////////////////////////////////////////
// CTickPropPage::CTickPropPage - Constructor

CTickPropPage::CTickPropPage() :
    COlePropertyPage(IDD, IDS_XRTTICKER_PPG_CAPTION)
{
    //{{AFX_DATA_INIT(CTickPropPage)
    m_strText = _T("");
    m_lSpeed = 0;
    m_lTickWidth = 0;
    m_fCacheOn = FALSE;
    m_fOffsetValues = FALSE;
    //}}AFX_DATA_INIT
}


/////////////////////////////////////////////////////////////////////////////
// CTickPropPage::DoDataExchange - Moves data between page and properties

void CTickPropPage::DoDataExchange(CDataExchange* pDX)
{
    //{{AFX_DATA_MAP(CTickPropPage)
    DDP_Text(pDX, IDC_EDIT1, m_strText, _T("Text") );
    DDX_Text(pDX, IDC_EDIT1, m_strText);
    DDP_Text(pDX, IDC_EDIT2, m_lSpeed, _T("ScrollSpeed") );
    DDX_Text(pDX, IDC_EDIT2, m_lSpeed);
    DDV_MinMaxLong(pDX, m_lSpeed, 1, 10000);
    DDP_Text(pDX, IDC_EDIT3, m_lTickWidth, _T("ScrollWidth") );
    DDX_Text(pDX, IDC_EDIT3, m_lTickWidth);
    DDV_MinMaxLong(pDX, m_lTickWidth, 1, 100);
    DDP_Check(pDX, IDC_CACHEON, m_fCacheOn, _T("CacheOn") );
    DDX_Check(pDX, IDC_CACHEON, m_fCacheOn);
    DDP_Check(pDX, IDC_OFFSETVALUES, m_fOffsetValues, _T("OffsetValues") );
    DDX_Check(pDX, IDC_OFFSETVALUES, m_fOffsetValues);
    //}}AFX_DATA_MAP
    DDP_PostProcessing(pDX);     
}


/////////////////////////////////////////////////////////////////////////////
// CTickPropPage message handlers

void CTickPropPage::OnAbout() 
{
    CDialog dlgAbout(IDD_ABOUTBOX_XRTTICKER,this);
    dlgAbout.DoModal();
}
/////////////////////////////////////////////////////////////////////////////
// CDataObjectPropPage dialog

IMPLEMENT_DYNCREATE(CDataObjectPropPage, COlePropertyPage)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CDataObjectPropPage, COlePropertyPage)
    //{{AFX_MSG_MAP(CDataObjectPropPage)
    // NOTE - ClassWizard will add and remove message map entries
    //    DO NOT EDIT what you see in these blocks of generated code !
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CDataObjectPropPage, "XRTTick.TickerPropPage.1",
    0xd50c40b0, 0xe21c, 0x11cd, 0x84, 0x45, 0x0, 0xaa, 0x0, 0x33, 0x97, 0x10)


/////////////////////////////////////////////////////////////////////////////
// CDataObjectPropPage::CDataObjectPropPageFactory::UpdateRegistry -
// Adds or removes system registry entries for CDataObjectPropPage

BOOL CDataObjectPropPage::CDataObjectPropPageFactory::UpdateRegistry(BOOL bRegister)
{
    if (bRegister)
        return AfxOleRegisterPropertyPageClass(AfxGetInstanceHandle(),
            m_clsid, IDS_DATAOBJECT_PPG);
    else
        return AfxOleUnregisterClass(m_clsid, NULL);
}


/////////////////////////////////////////////////////////////////////////////
// CDataObjectPropPage::CDataObjectPropPage - Constructor

CDataObjectPropPage::CDataObjectPropPage() :
    COlePropertyPage(IDD, IDS_DATAOBJECT_PPG_CAPTION)
{
    //{{AFX_DATA_INIT(CDataObjectPropPage)
    m_strDataObjectName = _T("");
    m_Active = FALSE;
    m_fDataObjectVisible = FALSE;
    m_fAutoStart = FALSE;
    m_fDataObjectActive = FALSE;
    m_strRequest = _T("");
    m_strNameProperty = _T("");
    m_strValueProperty = _T("");
    //}}AFX_DATA_INIT
}


/////////////////////////////////////////////////////////////////////////////
// CDataObjectPropPage::DoDataExchange - Moves data between page and properties

void CDataObjectPropPage::DoDataExchange(CDataExchange* pDX)
{
    // NOTE: ClassWizard will add DDP, DDX, and DDV calls here
    //    DO NOT EDIT what you see in these blocks of generated code !
    //{{AFX_DATA_MAP(CDataObjectPropPage)
    DDP_Text(pDX, ID_SERVERNAME, m_strDataObjectName, _T("DataObjectName") );
    DDX_Text(pDX, ID_SERVERNAME, m_strDataObjectName);
    DDP_Check(pDX, IDC_MAKESERVERVISIBLE, m_fDataObjectVisible, _T("DataObjectVisible") );
    DDX_Check(pDX, IDC_MAKESERVERVISIBLE, m_fDataObjectVisible);
    DDP_Check(pDX, IDC_AUTOSTART, m_fAutoStart, _T("AutoStartDataObject") );
    DDX_Check(pDX, IDC_AUTOSTART, m_fAutoStart);
    DDP_Check(pDX, IDC_ACTIVE, m_fDataObjectActive, _T("DataObjectActive") );
    DDX_Check(pDX, IDC_ACTIVE, m_fDataObjectActive);
    DDP_Text(pDX, IDC_REQUEST, m_strRequest, _T("DataObjectRequest") );
    DDX_Text(pDX, IDC_REQUEST, m_strRequest);
    DDP_Text(pDX, IDC_NAMEPROPERTY, m_strNameProperty, _T("DataObjectNameProperty") );
    DDX_Text(pDX, IDC_NAMEPROPERTY, m_strNameProperty);
    DDP_Text(pDX, IDC_VALUEPROPERTY, m_strValueProperty, _T("DataObjectValueProperty") );
    DDX_Text(pDX, IDC_VALUEPROPERTY, m_strValueProperty);
    //}}AFX_DATA_MAP
    DDP_PostProcessing(pDX);
}


/////////////////////////////////////////////////////////////////////////////
// CDataObjectPropPage message handlers
